#include<c8051f340.h> 
#include<TFT.h>
#include<delay.h>
#include<C8051F340.h>               
//#define SYSCLK       48000000          // Internal oscillator frequency in Hz
#define max_freq 108000 
#define min_freq 87500
#define max_pll 0x339b //108MHzʱpll.
#define min_pll 0x299d //87.5MHzʱpll. 

sbit scl=P3^0; 
sbit sda=P3^1;  
sbit s0=P3^2;       //Ƶʼ
sbit s1=P3^3;      //Ƶʼ
sbit s2=P3^4;
unsigned int iic_delay_time = 60; 
unsigned char DISPLAY[14]=" FM: 000.0MHZ";                   
unsigned char radio_write_data[5];
unsigned char radio_read_data[5];             //TEA5767״̬ 
unsigned int default_pll=0x2d56;              //Ĭϴ̨pll,95.3MHz ս 
unsigned int  pll; 
unsigned long frequency; 
/****************************************************
:nus_delay
:΢뼶ʱӳ
䡡: 
䡡: 
ڣ2009-4-8
˵:   
Ϊ11.0592Mʱ  
ڣ2009-4-7   

*****************************************************/
void nus_delay(unsigned int nus)
{
    int j=10;
    while(nus--)
    {
       while(j--);
	   j=10;
    }
}
/****************************************************
:nms_delay
:뼶ʱӳ
䡡: 
䡡: 
ڣ2009-4-8
˵:   
Ϊ11.0592Mʱ            
*****************************************************/
void nms_delay(unsigned int nms)
{
	while(nms--)
	nus_delay(300);
}

// delay 
void iic_delay(unsigned int m) 
{ 
     unsigned int n; 
     for(n=0;n<m;n++); 
} 
//I2CߵĺsclΪߵƽʱʹsdaһ  
void iic_start()  
{ 
     sda=1; 
     scl=1; 
     iic_delay(iic_delay_time); 
     sda=0; 
     iic_delay(iic_delay_time); 
     scl=0; 
     iic_delay(iic_delay_time/2); 
} 

//ֹI2CߣsclΪߵƽʱʹsdaһ 
void iic_stop()  
{ 
     sda=0; 
     scl=1; 
     iic_delay(iic_delay_time); 
     sda=1; 
     iic_delay(iic_delay_time); 
} 

//Ӧź 
void iic_ack(void)  
{ 
     sda=0; 
     scl=1; 
     scl=0; 
     sda=1; 
} 	 

//ȴӦź 
bit waitack(void) 
{ 
    unsigned char errtime=255;//ϽշACKʱֵΪ255 
    sda=1; 
    iic_delay(iic_delay_time); 
    while(sda) 
    { 
        errtime--; 
        if (!errtime)         //Ӧʱ˳
        { 
        iic_stop();  
        return 0;             //Ӧ𷵻0
        } 
    } 
    scl=1; 
    iic_delay(iic_delay_time); 
    scl=0; 
    return 1; 				  //Ӧ򷵻1
} 

//һֽ 
void iic_write8bit(unsigned char input)  
{ 
     unsigned char temp; 
     for(temp=0;temp<8;temp++)  
     { 
        if((input<<temp)&0x80) 
            sda=1; 
        else 
            sda=0; 
        
		//һ
		scl=1; 
        iic_delay(iic_delay_time); 
        scl=0; 	             //ʱӵ½д
     } 
} 

//һֽ 
unsigned char iic_read8bit(void)  
{ 
    unsigned char temp,rbyte=0; 
    for(temp=0;temp<8;temp++)  
    { 
        scl=1; 
        iic_delay(iic_delay_time); 
        if(sda) 
            rbyte=(rbyte<<1)+1; 
        else 
            rbyte=rbyte<<1; 
        scl=0; 
    } 
    return(rbyte); 
} 

/********************************/ 
//ƵʼPLL 
void get_pll(void) 
{ 
     unsigned char hlsi; 
     unsigned int twpll=0; 
     hlsi=radio_write_data[2]&0x10; 
     if (hlsi) 
        pll=(unsigned int)((float)((frequency+225)*4)/(float)32.768);    //Ƶʵλ:k 
     else 
        pll=(unsigned int)((float)((frequency-225)*4)/(float)32.768);    //Ƶʵλ:k 
} 
//PLLƵ 
void get_frequency(void) 
{ 
     unsigned char hlsi; 
     unsigned int npll=0; 
     npll=pll; 
     hlsi=radio_write_data[2]&0x10; 
     if (hlsi) 
        frequency=(unsigned long)((float)(npll)*(float)8.192-225);    //Ƶʵλ:KHz 
     else 
        frequency=(unsigned long)((float)(npll)*(float)8.192+225);    //Ƶʵλ:KHz 
} 
//д5767 
//˳Ϊ: ַ  ֽ1  ֽ2 ֽ3 ֽ4 ֽ5  
void radio_write(void) 
{ 
     unsigned char i; 
     iic_start(); 		         //
     iic_write8bit(0xc0);        //дTEA5767ַ 
     waitack();                  //ȴӦź
     for(i=0;i<5;i++)            //д5ֽ
     { 
         iic_write8bit(radio_write_data[i]); 
         waitack();    
     }  
     iic_stop();     	        //ֹͣ
} 

//TEA5767״̬,תƵ 
void radio_read(void) 
{ 
     unsigned char i; 
     unsigned char temp_l,temp_h; 
     pll=0; 
     iic_start();                //
     iic_write8bit(0xc1);        //дTEA5767ַ 
     waitack(); 		         //ȵӦź
     
     for(i=0;i<5;i++) 	         //5ֽ
     { 
        radio_read_data[i]=iic_read8bit(); 
        iic_ack(); 				 
     } 
     
     iic_stop(); 		          //ֹͣ
     temp_l=radio_read_data[1]; 
     temp_h=radio_read_data[0]; 
     temp_h&=0x3f; 
     pll=temp_h*256+temp_l; 
     get_frequency(); 
} 

//Զ̨mode=1,Ƶ̨; mode="0:ƵʼС̨
void auto_search(unsigned char mode)
{
	radio_read();
	get_pll();
	if(mode)
	{
		radio_write_data[2] = 0xa1;
		if(pll>max_pll) 
         pll=min_pll;
	}
	else
	{
		radio_write_data[2] = 0x21;
		if(pll<min_pll) 
         pll=max_pll;
	}

	radio_write_data[0] = pll/256+0x40;
	radio_write_data[1] = pll%256; 
	radio_write_data[3] = 0x11;
	radio_write_data[4] = 0x40;
	radio_write();
	radio_read();
	while(!(radio_read_data[0]&0x80)) //RF̨־
	{
		radio_read();
	} 
}

void OSCILLATOR_Init1(void)
{
     FLSCL     = 0x80;  //ĳ0x80
    CLKMUL    = 0x00;  //ĳ0x00  ֹʱӳ˷

    CLKSEL    = 0x00; //ĳ0x00  ʹڲ ʹ4ʱӳ˷
    OSCICN    = 0x83;  //  ڲʱ ϵͳʱƵʵڲʱƵ  
//    OSCICN    = 0x83;                    // Configure internal oscillator for
                                       // its maximum frequency (24.5 Mhz)
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
/*
void PORT_Init (void)
{
   	P4MDOUT=0xFF;
    P3MDOUT = 0x01; 
	P2MDOUT=0xFF;
	P0MDOUT=0xFF;
	P1MDOUT   = 0xFF;

	XBR0      = 0x01;
	XBR1      = 0x40;   
}
*/
void display_chang(void)
{
     DISPLAY[5]=frequency/100000 + '0';
	 DISPLAY[6]=(frequency%100000)/10000 + '0';
	 DISPLAY[7]=(frequency%10000)/1000 + '0';
	 DISPLAY[9]=(frequency%1000)/100 + '0';
	 TftWR_Str(100,100,DISPLAY,BLACK,WHITE);
}
void fm (void)
{
//   unsigned char radio_write_data[5]={0x33,0x9B,0x20,0x11,0x00};
//   PCA0MD &= 0x00;
   OSCILLATOR_Init1(); 
//   PORT_Init ();

   Tft_Init();          //TFTʼ
   TftClear(WHITE);       //
     pll=min_pll;
	 get_frequency();
     radio_write_data[0]=pll/256; 
     radio_write_data[1]=pll%256; 
     radio_write_data[2]=0x20; 
     radio_write_data[3]=0x11; 
     radio_write_data[4]=0x00; 
     radio_write(); 
	display_chang();
   while (s2==1)
   {
     radio_read();
	  if(s1==0)
		{
            nms_delay(5);
              if(s1==0)
                {
				while(s1==0);
				auto_search(1);
		        display_chang();
				}
		 } 
	   if(s0==0)
		{
             nms_delay(5);
			  if(s0==0)
                {
				while(s0==0);
				auto_search(0); 
		        display_chang();
			   }
		}
//	break;                  
   }                                   // end of while(1)
}                                      // end of main()
